<?php
class smilepayatm{
    var $code, $title, $titlep, $description, $enabled;

    protected $smse_url='https://ssl.smse.com.tw/api/SPPayment.asp';

	function __construct() {
      global $order,$db;

      $this->code = 'smilepayatm';
      $this->title = MODULE_PAYMENT_SMILEPAYATM_TEXT_TITLE; 
      $this->titlep = MODULE_PAYMENT_SMILEPAYATM_TEXT_TITLEP;
      $this->description = MODULE_PAYMENT_SMILEPAYATM_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_SMILEPAYATM_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_SMILEPAYATM_STATUS == 'True') ? true : false);
      //$this->form_action_url = MODULE_PAYMENT_SMILEPAYATM_KEY_URL;
      
      
      if ((int)MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID;
      }

  }

	function update_status() {
      global $order,$db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SMILEPAYATM_ZONE > 0) ) {
        $check_flag = false;
        $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SMILEPAYATM_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");  
        $check_zone_id = $check_query->fields['zone_id'];        
          if ($check_zone_id < 1) {
            $check_flag = true;
          
          } elseif ($check_zone_id == $order->billing['zone_id']) {
            $check_flag = true;
         
          }       
          if ($check_flag == false) {
          $this->enabled = false;
          }
      }
    }

    function javascript_validation() {     
      return false;
    }

   function selection() {
     //<SmilePay> smilepayc2cp start
     if(!class_exists('smilepayc2cp'))
       include_once(DIR_WS_MODULES."shipping/smilepayc2cp.php");
     $smilepayc2cp_obj = new smilepayc2cp();
     //當選擇取貨付款時不顯示此付費方式
     if( $smilepayc2cp_obj->isC2CShippingMethod($_SESSION['shipping']['id']))
     {
          return false;
     }
     //<SmilePay> smilepayc2cp end	         
      $selection = array('id' => $this->code,
                       'module' => $this->titlep,                       
                       'fields' => array(array('title' => MODULE_PAYMENT_SMILEPAYATM_PAYER_NAME,),));
        return $selection;               
	 } 

    function pre_confirmation_check() {
      global $order,$HTTP_POST_VARS;

      
      $DealerCode=MODULE_PAYMENT_SMILEPAYATM_DEALERCODE;
      $Rvg2c = MODULE_PAYMENT_SMILEPAYATM_RVG2C;
      $Verify_key = MODULE_PAYMENT_SMILEPAYATM_VERIFY_KEY; 
       if ( $order->info[total] < 0 ) {   
		        $result = false ;
		        $error = 1 ;
		        $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
		        twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
	     } elseif(empty($DealerCode) || empty($Rvg2c) || empty($Verify_key) ){
		  $result = false ;
  		  $error = MODULE_PAYMENT_SMILEPAYATM_SMILEPAY_ARG_ERROR ;
  		  $payment_error_return = 'error_message=' . urlencode($error) ;
  		  twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
           
	   }
       else
          $result = true ;
	     return $result ;
    }


    function confirmation() { 
      global $order,$db ;
      if ( $_SESSION['step'] == "" ) {
  			$_SESSION['step'] = 1 ;
  	  } else {
  			$_SESSION['step']++ ;
  	  }

      //<SmilePay> c2cup start
      //validate
      if(class_exists('smilepayc2cup'))
      {

          $smilepayc2cup_obj = new smilepayc2cup();

          $smilepayc2cup_obj->pre_validate_order();
        
      }
      //<SmilePay> c2cup end


  	/*//商家代號及參數          
    $DealerCode=MODULE_PAYMENT_SMILEPAYATM_DEALERCODE;
    if ($DealerCode==" ") {
			  $DealerCode = "9999999" ;			
	  }   
        
    //加密參數    
  	$encode=MODULE_PAYMENT_SMILEPAYATM_PASSCODE;
  	$passcode=$DealerCode .$encode;
  	$passcode_in=sha1($passcode);	
    //訂單編號計算
 	  $oid_query =$db->Execute("SHOW TABLE STATUS LIKE '" . TABLE_ORDERS ."'");    
	  $oid_array = $oid_query->fields['Auto_increment'];	
	  $oid = date('mdHi')."-".$oid_array;
	  //客戶姓名-地址-消費項目
	  $customer=$order->customer['firstname'] .$order->customer['lastname'];	  
	  $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
    //$sname=STORE_NAME."_".$order->products[0]['name'];     
    $sname=mb_substr($order->products[0]['name'],0,14,'utf-8');
	  //讀取簡訊設定    
    $SMSCA = MODULE_PAYMENT_SMILEPAYATM_SMS_CA ;   
    $SMSSB = MODULE_PAYMENT_SMILEPAYATM_SMS_SB ;	
    $SMSCUSB = MODULE_PAYMENT_SMILEPAYATM_SMS_CUSB ;
    //回傳respond位置  
    $locallink=( ENABLE_SSL ?  'https://' : 'http://' ) . $_SERVER['SERVER_NAME']. substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'],"/") + 1);
    $roturl=$locallink."smilepayrespond.php";    
         
      //post表單
    $pargams =  'Dcvc=' .$DealerCode.
                              '&Rvg2c=1'.              
                              '&Amount=' .urlencode(round($order->info[total])).
                              '&Remark=' . $passcode_in.                              
                              '&Data_id=' . $oid . "-" . substr(($_SESSION['step']+100),1).
                              '&Od_sob=' .$sname.
                              '&Pur_name=' .$customer.
                              '&Address=' . $street_address.
                              '&Email=' .$order->customer['email_address'].
                              '&Mobile_pur='.$order->customer['fax'].
                              '&Pay_zg=2'.
                              '&Pay_gdry=TW'.
                              '&Mobile_rvg=' . $SMSCA.
                              '&Sms_rvg=' . $SMSSB.
                              '&Sms_pur='.$SMSCUSB.
                              '&Tel_number='.$order->customer['telephone'].
                              '&Roturl_status=tweok'.                              
                              '&Roturl=' . $roturl;                                                                                                                                                          
                             //'&Twesid=' . twe_session_id();

//MODULE_PAYMENT_SMILEPAYATM_KEY_URL
     $pay_button = '<a href="'.MODULE_PAYMENT_SMILEPAYATM_KEY_URL.'?'.$pargams.'" target="_blank" onclick="validate()"><button type="button">'.MODULE_PAYMENT_SMILEPAYATM_PAYER_BUTTON.'</button></a>';                          
     $scripts='<script>function validate(){
     document.forms["checkout_confirmation"].submit();
}</script>';      */                      
     return array('title' => MODULE_PAYMENT_SMILEPAYATM_PAYER_NAME ,      
     'fields' => array(
      // array('title'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_EMAIL,'field'=>$order->customer['email_address']),
       //array('title'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_CELLPHONE,'field'=>$order->customer['fax']),
       //array('title'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_AMOUNT,'field'=>urlencode(round($order->info[total]))),
      // array('title'=>'','field'=>$scripts),
      // array('title'=>'','field'=>$pay_button),
       array('title'=>'','field'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_NOTICE),
       array('title'=>'','field'=>MODULE_PAYMENT_SMILEPAYATM_PAYER_NOTICE_DOWN)
      )
     );       
    }

    function process_button() {
      global $order,$db,$customer_id ;
  	  if ( $_SESSION['step'] == "" ) {
  			$_SESSION['step'] = 1 ;
  	  } else {
  			$_SESSION['step']++ ;
  	  }
        

    //訂單編號計算
 	  $oid_query =$db->Execute("SHOW TABLE STATUS LIKE '" . TABLE_ORDERS ."'");    
	  $oid_array = $oid_query->fields['Auto_increment'];	
	  $oid = date('mdHi')."-".$oid_array;
 
        
      //post表單
    $process_button_string =twe_draw_hidden_field('Data_id', $oid . "-" . substr(($_SESSION['step']+100),1));
			                                                 
      return  $process_button_string;
	}                                                    

  function before_process() {                                                                
      global $order,$db;


       //<SmilePay> c2cup start
      //validate
      if(class_exists('smilepayc2cup'))
      {

          $smilepayc2cup_obj = new smilepayc2cup();
          $smilepayc2cup_obj->run_before_process();
  
      }
      //<SmilePay> c2cup end

      unset($_SESSION['smilepay_atm_results']);
 
      
     






      return false;
  }
  
  function after_process() {		                       
		global  $order,$insert_id,$db ;



    //    $amount =  intval(round($order->info['total']));
 
      //商家代號及參數          
      $DealerCode=MODULE_PAYMENT_SMILEPAYATM_DEALERCODE;
      $Rvg2c=MODULE_PAYMENT_SMILEPAYATM_RVG2C;
      $Verify_key = MODULE_PAYMENT_SMILEPAYATM_VERIFY_KEY;
      //訂單編號計算
 	  $oid_query =$db->Execute("SHOW TABLE STATUS LIKE '" . TABLE_ORDERS ."'");    
	  $oid_array = $oid_query->fields['Auto_increment']-1;	
	  $oid = date('mdHi')."-".$oid_array;
     
	  //客戶姓名-地址-消費項目
	  $customer=explode(' ',$order->customer['name']);// .$order->customer['lastname'];
    //  $customer=mb_substr($customer[0],0,5,'utf-8');
      $customer=$customer[0].$customer[1];

	  $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
      $sname=mb_substr($order->products[0]['name'],0,14,'utf-8');
      if($_SERVER['SERVER_PORT']!="80" || $_SERVER['SERVER_PORT']!="443")  
        $server_port = ":".$_SERVER['SERVER_PORT'];
      else
        $server_port="";
      $locallink=( ENABLE_SSL ?  'https://' : 'http://' ) . $_SERVER['SERVER_NAME'] .$server_port. substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'],"/") + 1);
      $roturl=$locallink."smilepayrespond.php";  
      $data_id=$oid . "-" . substr(($_SESSION['step']+100),1);

      if(!empty($order->delivery['fax']))
        $customer_mobile= $order->delivery['fax'];
      else
        $customer_mobile= $order->delivery['telephone'];
      if(isset( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT']) && !empty($_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT']))
        $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT'],'',$order->info['total']);
      else
        $amount= $order->info['total'];
      if(isset( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT']) && !empty($_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT']))
        $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT'],'',$amount);
      if(isset( $_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT']) && !empty($_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT']))
        $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT'],'',$amount);
         
      //post表單
      $pargams =  'Dcvc=' .$DealerCode.
                              '&Rvg2c='. trim($Rvg2c) .
                              '&Verify_key=' . trim($Verify_key) .              
                              '&Amount=' .  intval(round($amount)).
                              '&Remark=' . $passcode_in.                              
                              '&Data_id=' . $data_id.
                              '&Od_sob=' .$sname.
                              '&Pur_name=' .$customer.
                              '&Address=' . $street_address.
                              '&Email=' .$order->customer['email_address'].
                              '&Mobile_pur='.$order->customer['fax'].
                              '&Pay_zg=2'.
                              '&Pay_gdry=TW'.
                              '&Tel_number='.$order->customer['telephone'].
                              '&Roturl_status=tweok'.                              
                              '&Roturl=' . $roturl;   
 
  
      $ch1 = curl_init();
	  curl_setopt($ch1, CURLOPT_URL, $this->smse_url);
	  curl_setopt($ch1, CURLOPT_VERBOSE, 1);
	  curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, FALSE);
	  curl_setopt($ch1, CURLOPT_SSL_VERIFYHOST, FALSE);
	  curl_setopt($ch1, CURLOPT_POST, 1);
	  curl_setopt($ch1, CURLOPT_RETURNTRANSFER, 1);
	  curl_setopt($ch1, CURLOPT_POSTFIELDS, $pargams);
	  $string_1 = curl_exec($ch1);
	  curl_close($ch1);
	  $xmls = simplexml_load_string($string_1);
      $result=array();

      if(!is_null($xmls) && !empty($xmls))
      {
       
           $result['Amount'] = $xmls->Amount;
           $result['SmilePayNO'] = $xmls->SmilePayNO;
           $result['Data_id'] = $xmls->Data_id;
           $result['PayEndDate'] = $xmls->PayEndDate;
           $result['AtmBankNo'] = $xmls->AtmBankNo;
           $result['AtmNo'] = $xmls->AtmNo;
           $result['Status'] = $xmls->Status;
           if( $result['Status'] != '1')
              $result['Desc'] = $xmls->Desc;

      }
      else
      {
          //$Status = "-1000";
          $result['Status'] = '-1000';
          $result['Desc'] = 'Place Order fail.';
          $result['Data_id'] = $data_id;
      }

      $_SESSION['smilepay_atm_results'] = $result;



       //<SmilePay> c2cup start
      //validate
      if(class_exists('smilepayc2cup')&& $result['Status']==1)
      {

          $smilepayc2cup_obj = new smilepayc2cup();
          $smilepayc2cup_obj->run_process();
       
      }
      //<SmilePay> c2cup end


		$_SESSION['PAYMENTOID'] = $_POST['Data_id'] ;     		
		$db->Execute("update ".TABLE_ORDERS." set cc_owner='".$_SESSION['AUTHCODE']."', cc_number ='".$_SESSION['PAYMENTOID']."' where orders_id='".(int)$insert_id ."'");		
		unset($_SESSION['AUTHCODE']) ;                      
		unset($_SESSION['PAYMENTOID']) ;
		unset($_SESSION['step']) ;    
        $result=$_SESSION['smilepay_atm_results'];

       if($result['Status']=="1")
       {
            $orders_status=MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID;
            $is_dateline = count($result['PayEndDate']) > 9 ? true: false;

           // if($orders_status==0)
             //   $orders_status=1;
            

            if($is_dateline)
            {
                $admincomments   = sprintf(MODULE_PAYMENT_SMILEPAYATM_ADMIN_COMMENT_DATE_SUCCESS,$result['SmilePayNO'],$result['AtmBankNo'],$result['AtmNo'],$result['Amount'],$result['PayEndDate']);
                $template=sprintf(MODULE_PAYMENT_SMILEPAYATM_RESULT_DATE_SUCCESS,$result['AtmBankNo'],$result['AtmNo'],$result['Amount'],$result['PayEndDate']);
               // $customercomments = sprintf(MODULE_PAYMENT_SMILEPAYFAMI_CUSTOMER_COMMENT_SUCCESS,$result['FamiNO'],$result['Amount'],$result['PayEndDate']);
            }
            else
            {
                $admincomments   = sprintf(MODULE_PAYMENT_SMILEPAYATM_ADMIN_COMMENT_NODATE_SUCCESS,$result['SmilePayNO'],$result['AtmBankNo'],$result['AtmNo'],$result['Amount']);
                $template=sprintf(MODULE_PAYMENT_SMILEPAYATM_RESULT_NODATE_SUCCESS,$result['AtmBankNo'],$result['AtmNo'],$result['Amount']);
            }
            
            //$customercomments = sprintf(MODULE_PAYMENT_SMILEPAYFAMI_CUSTOMER_COMMENT_SUCCESS,$result['FamiNO'],$result['Amount'],$result['PayEndDate']);
            $comment_status = 'Add';
            $oID=explode ("-", $result['Data_id']);
            $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '0', '".$admincomments."')");
            //$db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '1', '".$customercomments."')");         
           
            $db->Execute("update " . TABLE_ORDERS  . " set orders_status='".$orders_status."' ,last_modified = now(),cc_expires ='".$comment_status."'  where orders_id = '" . (int)$oID[1] . "'");    
           
            $_SESSION['smilepay_results']= $template;
       }
       else
       {
            $orders_status=MODULE_PAYMENT_SMILEPAYATM_FAILED_STATUS_ID;
           //if($orders_status=='0')
              //  $orders_status=1;
            $comments   = "狀態碼：".$result['Status']."失敗原因：".$result['Desc'];
            $comment_status = 'Fail';
            $oID=explode ("-", $result['Data_id']);
            $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '0', '".$comments."')");      
            $db->Execute("update " . TABLE_ORDERS .  " set orders_status='".$orders_status."' ,last_modified = now(),cc_expires ='".$comment_status."'  where orders_id = '" . (int)$oID[1] . "'"); 

            $template=MODULE_PAYMENT_SMILEPAYATM_RESULT_FAILED;
            $_SESSION['smilepay_results']= $template;

       }

      //<SmilePay> c2cup start
      //validate
      if(class_exists('smilepayc2cup')&& $result['Status']==1)
      {

          $smilepayc2cup_obj = new smilepayc2cup();
          $smilepayc2cup_obj->run_after_process();
          $emap_template = $smilepayc2cup_obj->output_result(true);
          $_SESSION['smilepay_results'].= $emap_template;
      }
      //<SmilePay> c2cup end


       unset($_SESSION['smilepay_atm_results']);
       $_SESSION['cart']->reset(true);
    
       // unregister session variables used during checkout
       unset($_SESSION['sendto']);
       unset($_SESSION['billto']);
       unset($_SESSION['shipping']);
       unset($_SESSION['payment']);
       unset($_SESSION['comments']);
       unset($_SESSION['last_order']);
       $last_order = $insert_id;
       twe_redirect(twe_href_link('smilepay_success.php','','SSL'));
                       
    return true;
  } 
                                                       
  function respond(){
    global $db ;                                         
    $mitycat_type       = $_POST['Classif'];
    $mitycat_order      = $_POST['Data_id'];   
    $amount             = $_POST['Amount'] ;  
    $passcode_in        = $_POST['Remark'];
    $smseid             = $_REQUEST['Smseid'];  
    $mid_smilepay       = $_POST['Mid_smilepay'];    
        
    $DealerCode=MODULE_PAYMENT_SMILEPAYATM_DEALERCODE;
	//  $encode=MODULE_PAYMENT_SMILEPAYATM_PASSCODE;                
  	//$passcode=$DealerCode .$encode;
  	//$passcode_ou=sha1($passcode);                                                      	
    
      //checksum Mid and Mid_smilepay from SmielPay    
      $mid=MODULE_PAYMENT_SMILEPAYATM_MID;
      $mid_value=MODULE_PAYMENT_SMILEPAYATM_MID_VALUE;                               
      if($mid == 'True'){                         
        if(!$this->midfun($mid_value,$amount,$smseid,$mid_smilepay)){      
          echo  "Possible fraud";
          exit();
        }        
      }
      
     //check Amount 
    $order_id =explode ("-", $mitycat_order);    
    $totals = $db->Execute("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . twe_db_input($order_id[1]) . "' and class = 'ot_total' order by sort_order");
    $db_totals_value = $totals->fields['value'];
    if((int)$db_totals_value != $amount){
          echo  "Possible fraud Amount different";
          exit();
    }           
                                                           
    //判斷付費方式                                       
    if(( !empty($amount)) && $mitycat_type == 'B' ){
        $mitycat_transnum   ="已經收到您的付款，追蹤碼：".$_POST['Smseid'];
        $orders_status=MODULE_PAYMENT_SMILEPAYATM_ORDERED_STATUS_ID;
        //if(empty($orders_status))
         // $orders_status=2;
        $oID=explode ("-", $mitycat_order);
        $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '1', '".$mitycat_transnum."')");    
        $db->Execute("update " . TABLE_ORDERS . " set cc_type = '" . $mitycat_transnum . "',orders_status='".$orders_status."' ,last_modified = now(),cc_expires ='".$comments."'  where orders_id = '" . (int)$oID[1] . "'");        
        
        //mail process
        $db_result = $db->Execute( "select customers_id from ". TABLE_ORDERS . " where orders_id = '" .$oID[1] ."';");
        
        if($db_result->RecordCount()>0)
        {
            $customer_id = $db_result->fields['customers_id'];
            $db_result = $db->Execute( "select customers_email_address,customers_firstname,customers_lastname from ". TABLE_CUSTOMERS . " where customers_id = '" .$customer_id ."';");
            if($db_result->RecordCount()>0)
            {
                
                $customer_email = $db_result->fields['customers_email_address'];
                $customer_name = $db_result->fields['customers_firstname'].$db_result->fields['customers_lastname'];
                $mail_content =  STORE_NAME .'<br><br>親愛的客戶：<br><br>您好，<br>訂單'.$oID[1] ."已經收到您的付款，<br>此信為系統轉發，請勿回覆此信<br>謝謝。";
                $order_subject = STORE_NAME . '通知：已收到付款';
                //admin mail
                twe_php_mail(EMAIL_BILLING_ADDRESS,
                             EMAIL_BILLING_NAME,
                             EMAIL_BILLING_ADDRESS ,
                             EMAIL_BILLING_NAME,
                             '',
                             $customer_email,
                             $customer_name,
                             '',
                             '',
                             $order_subject,
                             '' ,
                             $mail_content );

                //customer mail
                twe_php_mail(EMAIL_BILLING_ADDRESS,EMAIL_BILLING_NAME , $customer_email, $customer_name, '', EMAIL_BILLING_REPLY_ADDRESS, EMAIL_BILLING_REPLY_ADDRESS_NAME, '', '',  $order_subject, '' , $mail_content);
            }
        }
      return "<Roturlstatus>tweok</Roturlstatus>";                             
    }
    else {                                                 
      return false;
    }                                                      
  }
  function get_error() {                                   
	  switch ($_GET['error']) {
		  case 1 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYATM_TEXT_ERROR_1 ;
		  break ;
		  case 2 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYATM_TEXT_ERROR_2 ;
		  break ;
	  }
      $error = array('title' => MODULE_PAYMENT_SMILEPAYATM_TEXT_ERROR,
                     'error' => $error_message );
    return $error;                                         
  }

    function remove() {
    	global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_SMILEPAYATM_ALLOWED', 'MODULE_PAYMENT_SMILEPAYATM_STATUS', 'MODULE_PAYMENT_SMILEPAYATM_ZONE', 'MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID','MODULE_PAYMENT_SMILEPAYATM_FAILED_STATUS_ID',  'MODULE_PAYMENT_SMILEPAYATM_DEALERCODE','MODULE_PAYMENT_SMILEPAYATM_RVG2C','MODULE_PAYMENT_SMILEPAYATM_VERIFY_KEY', 'MODULE_PAYMENT_SMILEPAYATM_SORT_ORDER','MODULE_PAYMENT_SMILEPAYATM_ORDERED_STATUS_ID','MODULE_PAYMENT_SMILEPAYATM_MID','MODULE_PAYMENT_SMILEPAYATM_MID_VALUE');
    }

	function check() {
	    global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SMILEPAYATM_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
  }

    function install() {
    	global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_ALLOWED', '', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_STATUS', 'True', '6', '1', 'twe_cfg_select_option(array(\'True\', \'False\'), ', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_ZONE', '0', '6', '2', 'twe_get_zone_class_title', 'twe_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_ORDER_STATUS_ID', '0', '6', '3', 'twe_cfg_pull_down_order_statuses(', 'twe_get_order_status_name', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_ORDERED_STATUS_ID', '0', '6', '3', 'twe_cfg_pull_down_order_statuses(', 'twe_get_order_status_name', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_FAILED_STATUS_ID', '0', '6', '3', 'twe_cfg_pull_down_order_statuses(', 'twe_get_order_status_name', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_DEALERCODE', '', '6', '4', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_RVG2C', '', '6', '4', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_VERIFY_KEY', '', '6', '4', now());");      

      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_SORT_ORDER', '0', '6', '7', now())");

      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_MID', 'False', '6', '6', 'twe_cfg_select_option(array(\'True\', \'False\'), ', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYATM_MID_VALUE', '', '6', '6', now());");
      

  }
  
  
  // compute Mid      
  function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
    $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
    $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
    $dtotal=$Mid_value. $Amount. $Smseid;                              
    
    $i = 1;
    $sum = strlen($dtotal);
    $etemp=0;      
    while ($i <= $sum)
    {
      $ep = substr($dtotal,$i,1);
      $etemp = $etemp + $ep;                
      $i=$i+2;
    }                
    
    $i = 0;  
    $otemp=0;          
    while ($i <= $sum)
    {                                              
      $op = substr($dtotal,$i,1);
      $otemp = $otemp + $op;
      $i=$i+2;
    } 
    
    $mid=($etemp*3)+($otemp*9);
  
    if($Mid_smilepay == $mid){
      return true;
    }else{
      return false;
    }
       
  }  
  
}
?>
