﻿<?php
class smilepaycredit {
    var $code, $title, $titlep, $description, $enabled;

	function __construct() {
      global $order,$db;

      $this->code = 'smilepaycredit';
      $this->title = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_TITLE;
      $this->titlep = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_TITLEP;
      $this->description = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_SMILEPAYCREDIT_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_SMILEPAYCREDIT_STATUS == 'True') ? true : false);
   //   $this->form_action_url = MODULE_PAYMENT_SMILEPAYCREDIT_KEY_URL;
      
      if ((int)MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID;
      }

   }

	function update_status() {
      global $order,$db;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_SMILEPAYCREDIT_ZONE > 0) ) {
        $check_flag = false;
        $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SMILEPAYCREDIT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        $check_zone_id = $check_query->fields['zone_id'];
          if ($check_zone_id < 1) {
            $check_flag = true;
            
          } elseif ($check_zone_id == $order->billing['zone_id']) {
            $check_flag = true;
           
          }        

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {	
     //<SmilePay> smilepayc2cp start
     if(!class_exists('smilepayc2cp'))
       include_once(DIR_WS_MODULES."shipping/smilepayc2cp.php");
     $smilepayc2cp_obj = new smilepayc2cp();
     //當選擇取貨付款時不顯示此付費方式
     if( $smilepayc2cp_obj->isC2CShippingMethod($_SESSION['shipping']['id']))
     {
          return false;
     }
     //<SmilePay> smilepayc2cp end
        $selection = array('id' => $this->code,
                       'module' => $this->titlep,
                       'fields' => array(array('title' => MODULE_PAYMENT_SMILEPAYCREDIT_PAYER_NAME,),));
        return $selection;               
	}

    function pre_confirmation_check() {
      global $order,$HTTP_POST_VARS;
      $DealerCode=MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE;
      $Rvg2c = MODULE_PAYMENT_SMILEPAYCREDIT_RVG2C;
      $Verify_key = MODULE_PAYMENT_SMILEPAYCREDIT_VERIFY_KEY;

      if ( $order->info['total'] < 0) {
    		  $result = false ;
    		  $error = 1 ;
    		  $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
    		  twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
	    } elseif(empty($DealerCode) || empty($Rvg2c) || empty($Verify_key) ){
		  $result = false ;
  		  $error = MODULE_PAYMENT_SMILEPAYCREDIT_SMILEPAY_ARG_ERROR ;
  		  $payment_error_return = 'error_message=' . urlencode($error) ;
  		  twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
           
	   }
       else
          $result = true ;
	    return $result ;
    }


    function confirmation() {
        //<SmilePay> c2cup start
      //validate
      if(class_exists('smilepayc2cup'))
      {

          $smilepayc2cup_obj = new smilepayc2cup();

          $smilepayc2cup_obj->pre_validate_order();
        
      }
      //<SmilePay> c2cup end
      return array('title' => MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_CONFIRMATION);
    }

    function process_button() {
      global $order,$db,$customer_id ;
  	  if ( $_SESSION['step'] == "" ) {
  			$_SESSION['step'] = 1 ;
  	  } else {
  			$_SESSION['step']++ ;
  	  }
  	//商家代號及參數          
    $DealerCode=MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE;
    $Rvg2c=MODULE_PAYMENT_SMILEPAYCREDIT_RVG2C;
    $Verify_key = MODULE_PAYMENT_SMILEPAYCREDIT_VERIFY_KEY;

    if(!empty($DealerCode))
        $DealerCode=trim( $DealerCode);
    if(!empty($Rvg2c))
        $Rvg2c=trim( $Rvg2c);
    if(!empty($Verify_key))
        $Verify_key=trim( $Verify_key);

    /*if ($DealerCode=="") {
			  $DealerCode = "9999999" ;			
	  }*/        
    //加密參數    
  	//$encode=MODULE_PAYMENT_SMILEPAYCREDIT_PASSCODE;
  	//$passcode=$DealerCode .$encode;
  	//$passcode_in=sha1($passcode);
    //訂單編號計算
 	  $oid_query =$db->Execute("SHOW TABLE STATUS LIKE '" . TABLE_ORDERS ."'");    
	  $oid_array = $oid_query->fields['Auto_increment'];	
	  $oid = date('mdHi')."-".$oid_array;
	  //客戶姓名-地址-消費項目
	  $customer=$order->customer['firstname'] ;//.$order->customer['lastname'];	  
	  $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
    //$sname=STORE_NAME."_".$order->products[0]['name'];
    $sname=mb_substr($order->products[0]['name'],0,14,'utf-8');
     //讀取簡訊設定    
    //$SMSCA = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CA ;   
    //$SMSSB = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_SB ;	
    //$SMSCUSB = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CUSB ;
    //回傳respond位置
    if($_SERVER['SERVER_PORT']!="80" || $_SERVER['SERVER_PORT']!="443")  
        $server_port = ":".$_SERVER['SERVER_PORT'];
    else
        $server_port="";
    $locallink=( ENABLE_SSL ?  'https://' : 'http://' ) . $_SERVER['SERVER_NAME'] . $server_port . substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'],"/") + 1);
    $roturl=$locallink."smilepayrespond.php"; 
    //post表單
    $process_button_string = twe_draw_hidden_field('Dcvc', $DealerCode) .
                              twe_draw_hidden_field('Rvg2c', $Rvg2c) .              
                              twe_draw_hidden_field('Amount', urlencode(round($order->info['total']))) .
                              twe_draw_hidden_field('Remark', $passcode_in) .                              
                              twe_draw_hidden_field('Data_id', $oid . "-" . substr(($_SESSION['step']+100),1)) .
                              twe_draw_hidden_field('Od_sob', $sname).
                              twe_draw_hidden_field('Pur_name', $customer).
                              twe_draw_hidden_field('Address', $street_address ).
                              twe_draw_hidden_field('Email',$order->customer['email_address']).
                             // twe_draw_hidden_field('Mobile_rvg', $SMSCA) .
                             // twe_draw_hidden_field('Sms_rvg', $SMSSB) .
                              twe_draw_hidden_field('Mobile_pur',$order->customer['fax']).
                            //  twe_draw_hidden_field('Sms_pur',$SMSCUSB).
                              twe_draw_hidden_field('Pay_zg',"1").
                              twe_draw_hidden_field('Pay_gdry',"TW").
                              twe_draw_hidden_field('Tel_number',$order->customer['telephone']).                                                         
                              twe_draw_hidden_field('Roturl', $roturl) .                                                                                                 
                              twe_draw_hidden_field('Twesid', twe_session_id());
    return false;
    return $process_button_string;
	}

    function before_process() {   
      global $order,$db,$customer_id ;
       //<SmilePay> c2cup start
      //validate
      if(class_exists('smilepayc2cup'))
      {

          $smilepayc2cup_obj = new smilepayc2cup();
          $smilepayc2cup_obj->run_before_process();
  
      }
      //<SmilePay> c2cup end

  	  if ( $_SESSION['step'] == "" ) {
  			$_SESSION['step'] = 1 ;
  	  } else {
  			$_SESSION['step']++ ;
  	  }
  	//商家代號及參數          
    $DealerCode=MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE;
    $Rvg2c=MODULE_PAYMENT_SMILEPAYCREDIT_RVG2C;
    $Verify_key = MODULE_PAYMENT_SMILEPAYCREDIT_VERIFY_KEY;

    if(!empty($DealerCode))
        $DealerCode=trim( $DealerCode);
    if(!empty($Rvg2c))
        $Rvg2c=trim( $Rvg2c);
    if(!empty($Verify_key))
        $Verify_key=trim( $Verify_key);

        
    //加密參數    
  	//$encode=MODULE_PAYMENT_SMILEPAYCREDIT_PASSCODE;
  	//$passcode=$DealerCode .$encode;
  	//$passcode_in=sha1($passcode);
    //訂單編號計算
 	  $oid_query =$db->Execute("SHOW TABLE STATUS LIKE '" . TABLE_ORDERS ."'");    
	  $oid_array = $oid_query->fields['Auto_increment'];	
	  $oid = date('mdHi')."-".$oid_array;
	  //客戶姓名-地址-消費項目
	  $customer=$order->customer['firstname'] .$order->customer['lastname'];	  
	  $street_address = $order->customer['state'] . $order->customer['city'] .  $order->customer['street_address'] ;
    //$sname=STORE_NAME."_".$order->products[0]['name'];
    $sname=mb_substr($order->products[0]['name'],0,14,'utf-8');
     //讀取簡訊設定    
    //$SMSCA = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CA ;   
    //$SMSSB = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_SB ;	
    //$SMSCUSB = MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CUSB ;
    //回傳respond位置
    if($_SERVER['SERVER_PORT']!="80" || $_SERVER['SERVER_PORT']!="443")  
        $server_port = ":".$_SERVER['SERVER_PORT'];
    else
        $server_port="";
    $locallink=( ENABLE_SSL ?  'https://' : 'http://' ) . $_SERVER['SERVER_NAME'] . $server_port . substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'],"/") + 1);
    $roturl=$locallink."smilepayrespond.php"; 
    //post表單
    require_once(DIR_FS_INC . 'twe_draw_hidden_field.inc.php');
    header("Content-Type:text/html; charset=utf-8");
    $process_button_string = "<p>訂單送出中，導向刷卡頁面，請稍後，請勿重新整理頁面</p>";
    $process_button_string .= "<form action='".MODULE_PAYMENT_SMILEPAYCREDIT_KEY_URL. "' method='POST' id='smilepaycredit_trade_form'>" ;
    $process_button_string .= twe_draw_hidden_field('Dcvc', $DealerCode) .
                              twe_draw_hidden_field('Rvg2c', $Rvg2c) .              
                              twe_draw_hidden_field('Remark', $passcode_in) .                              
                              twe_draw_hidden_field('Data_id', $oid . "-" . substr(($_SESSION['step']+100),1)) .
                              twe_draw_hidden_field('Od_sob', $sname).
                              twe_draw_hidden_field('Pur_name', $customer).
                              twe_draw_hidden_field('Address', $street_address ).
                              twe_draw_hidden_field('Email',$order->customer['email_address']).
                              twe_draw_hidden_field('Mobile_pur',$order->customer['fax']).
                              twe_draw_hidden_field('Pay_zg',"1").
                              twe_draw_hidden_field('Pay_gdry',"TW").
                              twe_draw_hidden_field('Tel_number',$order->customer['telephone']).                                                         
                              twe_draw_hidden_field('Roturl', $roturl) .                                                                                                 
                              twe_draw_hidden_field('Twesid', twe_session_id());
                        
       $_SESSION['smilepaycredit_form'] = $process_button_string;
       
       //<SmilePay> c2cup start
        //validate
        if(class_exists('smilepayc2cup'))
        {
         
          $smilepayc2cup_obj = new smilepayc2cup();
          $smilepayc2cup_obj->run_for_credit_card_before_process();//save post data
        }
        //<SmilePay> c2cup end


  	    return false;
    }
    function after_process() {
      global $order,$insert_id,$db ; 
  		$_SESSION['PAYMENTOID'] = $_POST['Data_id'] ;     		
  		$db->Execute("update ".TABLE_ORDERS." set cc_owner='".$_SESSION['AUTHCODE']."', cc_number ='".$_SESSION['PAYMENTOID']."' where orders_id='".(int)$insert_id ."'");		
  		unset($_SESSION['AUTHCODE']) ;
  		unset($_SESSION['PAYMENTOID']) ;
  		unset($_SESSION['step']) ;   
        $tmp_form=$_SESSION['smilepaycredit_form'] ;

        $orders_status=MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID;

        $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified) values ('" . (int)$insert_id . "', '" .$orders_status . "', now(), '1');");    
        $db->Execute("update " . TABLE_ORDERS . " set orders_status='".$orders_status."' ,last_modified = now()" ."  where orders_id = '" . (int)$insert_id. "'");

      

        if(isset( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT']) && !empty($_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT']))
            $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_LEFT'],'',$order->info['total']);
        else
            $amount= $order->info['total'];
        if(isset( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT']) && !empty($_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT']))
            $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['SYMBOL_RIGHT'],'',$amount);
        if(isset( $_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT']) && !empty($_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT']))
            $amount= str_replace( $_SESSION['SYMBOL_CURRENCY']['THOUSANDS_POINT'],'',$amount);
         //<SmilePay> c2cup start
        if(class_exists('smilepayc2cup'))
        {

          $smilepayc2cup_obj = new smilepayc2cup();
          if($smilepayc2cup_obj->isC2CShippingMethod($_SESSION['shipping']['id']))
          {
              $smilepayc2cup_obj->run_for_credit_card_process_save_total( $amount);
          }
  
        }
         //<SmilePay> c2cup end
       $tmp_form .= twe_draw_hidden_field('Amount', urlencode(intval(round($amount)))) ;
       $tmp_form .= "</form>";
       $tmp_script = "<script type='text/javascript'>document.getElementById('smilepaycredit_trade_form').submit();</script>";
     
        $tmp_form .= $tmp_script ;
        unset($_SESSION['smilepaycredit_form']);

        
        
        
        
        echo $tmp_form;
        
          exit;
      return true;          
    }
    
    function respond(){
     global $db ;  
      $respid             = $_POST['Response_id'];
      $mitycat_type       = $_POST['Classif'];
      $mitycat_order      = $_POST['Data_id'];
      $amount             = $_POST['Amount'];
      $passcode_in        = $_POST['Remark'];      
      $smseid             = $_REQUEST['Smseid'];  
      $mid_smilepay       = $_POST['Mid_smilepay']; 
            
  	  $DealerCode=MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE;


      $_SESSION['cart']->reset(true);
    
       // unregister session variables used during checkout
       unset($_SESSION['sendto']);
       unset($_SESSION['billto']);
       unset($_SESSION['shipping']);
       unset($_SESSION['payment']);
       unset($_SESSION['comments']);
       unset($_SESSION['last_order']);

  	//  $encode=MODULE_PAYMENT_SMILEPAYCREDIT_PASSCODE;        
    	//$passcode=$DealerCode .$encode;
    	//$passcode_ou=sha1($passcode);
     
      //checksum Mid and Mid_smilepay from SmielPay    
      $mid=MODULE_PAYMENT_SMILEPAYCN_MID;
      $mid_value=MODULE_PAYMENT_SMILEPAYCN_MID_VALUE;                               
      if($mid == 'True'){                         
        if(!$this->midfun($mid_value,$amount,$smseid,$mid_smilepay)){      
          echo  "Possible fraud";
          exit();
        }        
      }          
      
      if(( !empty($amount))&& ($mitycat_type == 'A' && $respid=='1')){
        $trade_time =  $_POST['Process_date']." ". iconv('BIG5','UTF-8',$_POST['Process_time']);
          
        $mitycat_transnum   = "刷卡成功，追蹤碼：".$_REQUEST['Smseid']."，交易金額：".$amount."，刷卡時間：" . $trade_time;
        $orders_status=MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_STATUS_ID;
        /*if(empty($orders_status))
            $orders_status =2;*/
        $comments='paid';
        $oID=explode ("-", $mitycat_order);
        $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '1', '".$mitycat_transnum."')");
        $db->Execute("update " . TABLE_ORDERS . " set orders_status='".$orders_status."' ,last_modified = now(),cc_expires ='".$comments."'  where orders_id = '" . (int)$oID[1] . "'");
        //$db->Execute("update " . TABLE_ORDERS . " set cc_type = '" . $mitycat_transnum . "',orders_status='".$orders_status."' ,last_modified = now(),cc_expires ='".$comments."'  where orders_id = '" . (int)$oID[1] . "'");
       // twe_session_unregister('payment');        
       // $_SESSION['cart']->reset(true);
        
     
       //mail process
        $db_result = $db->Execute( "select customers_id from ". TABLE_ORDERS . " where orders_id = '" .$oID[1] ."';");
        
        if($db_result->RecordCount()>0)
        {
            $customer_id = $db_result->fields['customers_id'];
            $db_result = $db->Execute( "select customers_email_address,customers_firstname from ". TABLE_CUSTOMERS . " where customers_id = '" .$customer_id ."';");
            if($db_result->RecordCount()>0)
            {
                
                $customer_email = $db_result->fields['customers_email_address'];
                $customer_name = $db_result->fields['customers_firstname'];
                $mail_content =  STORE_NAME .'<br><br>親愛的客戶：<br><br>您好，<br>訂單'.$oID[1] ."已經收到您的付款，<br>此信為系統轉發，請勿回覆此信<br>謝謝。";
                $order_subject = STORE_NAME . '通知：已收到付款';
                //admin mail
                twe_php_mail(EMAIL_BILLING_ADDRESS,
                             EMAIL_BILLING_NAME,
                             EMAIL_BILLING_ADDRESS ,
                             EMAIL_BILLING_NAME,
                             '',
                             $customer_email,
                             $customer_name,
                             '',
                             '',
                             $order_subject,
                             '' ,
                             $mail_content );

                //customer mail
                twe_php_mail(EMAIL_BILLING_ADDRESS,EMAIL_BILLING_NAME , $customer_email, $customer_name, '', EMAIL_BILLING_REPLY_ADDRESS, EMAIL_BILLING_REPLY_ADDRESS_NAME, '', '',  $order_subject, '' , $mail_content);
            }
        }
        //<SmilePay> c2cup start
        //validate
         $db_result = $db->Execute( "select shipping_class from ". TABLE_ORDERS . " where orders_id = '" .$oID[1] ."';");
        
        if($db_result->RecordCount()>0)
        {
            $shipping_class = $db_result->fields['shipping_class'];
            include_once(DIR_WS_MODULES."shipping/smilepayc2cup.php");
            $smilepayc2cup_obj = new smilepayc2cup();

            if($smilepayc2cup_obj->isC2CShippingMethod($shipping_class))
            {
                $template = "<h1>繳費資訊</h1><p style='font-size:16px;'>$mitycat_transnum</p>";

                include_once(DIR_WS_LANGUAGES . $_SESSION['language'] . '/modules/shipping/smilepayc2cup.php'); // language
                $smilepayc2cup_obj->run_for_credit_card_process();
                $smilepayc2cup_obj->run_after_process();
                $emap_template = $smilepayc2cup_obj->output_result(true);
                $template .= $emap_template;
                $_SESSION['smilepay_results']=   $template ;
                
            }
        }
        
        //<SmilePay> c2cup end

        twe_redirect(twe_href_link('smilepay_success.php', '', 'SSL', true, false));

     //   $msg=twe_redirect(twe_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL', true, false));        
        return $msg;        
          
        }else{
            $trade_time =  $_POST['Process_date']." ". iconv('BIG5','UTF-8',$_POST['Process_time']);
            
        //$error = 2 ;
  			//$payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) ;
            $errormsg=iconv('BIG5','UTF-8', $_POST['Errdesc']);
           
            
            $_SESSION['smilepay_results']= sprintf(MODULE_PAYMENT_SMILEPAYCREDIT_PAID_FAILED,$errormsg);
            $comments=sprintf(MODULE_PAYMENT_SMILEPAYCREDIT_PAID_COMMENT_FAILED,$errormsg,$smseid,$trade_time);

            $orders_status =MODULE_PAYMENT_SMILEPAYCREDIT_FAILED_STATUS_ID; //fail status
           // if(empty($orders_status))
            //    $orders_status =2;
            $oID=explode ("-", $mitycat_order);
            $db->Execute("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id, orders_status_id, date_added, customer_notified, comments) values ('" . (int)$oID[1] . "', '" .$orders_status . "', now(), '1', '".$comments."')");
            $db->Execute("update " . TABLE_ORDERS . " set "  . "orders_status='".$orders_status."' ,last_modified = now()  where orders_id = '" . (int)$oID[1]  . "';");
            
           

            twe_redirect(twe_href_link('smilepay_success.php', '', 'SSL', true, false));

  			//twe_redirect(twe_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
  	    return false;
      }
     }    

    function get_error() {
	  switch ($_GET['error']) {
		  case 1 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_ERROR_1 ;
		  break ;
		  case 2 :
		  	$error_message = MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_ERROR_2 ;
		  break ;
	  }
      $error = array('title' => MODULE_PAYMENT_SMILEPAYCREDIT_TEXT_ERROR,
                     'error' => $error_message );
      return $error;
    }

    function remove() {
    	global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_SMILEPAYCREDIT_ALLOWED', 'MODULE_PAYMENT_SMILEPAYCREDIT_STATUS', 'MODULE_PAYMENT_SMILEPAYCREDIT_ZONE', 'MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID','MODULE_PAYMENT_SMILEPAYCREDIT_FAILED_STATUS_ID',  'MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE','MODULE_PAYMENT_SMILEPAYCREDIT_RVG2C','MODULE_PAYMENT_SMILEPAYCREDIT_VERIFY_KEY' ,'MODULE_PAYMENT_SMILEPAYCREDIT_SORT_ORDER','MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_STATUS_ID','MODULE_PAYMENT_SMILEPAYCREDIT_MID','MODULE_PAYMENT_SMILEPAYCREDIT_MID_VALUE');
    }

	function check() {
	global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SMILEPAYCREDIT_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
    	global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ALLOWED', '', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_STATUS', 'True', '6', '1', 'twe_cfg_select_option(array(\'True\', \'False\'), ', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, use_function, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ZONE', '0', '6', '2', 'twe_get_zone_class_title', 'twe_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ORDER_STATUS_ID', '0', '6', '3', 'twe_cfg_pull_down_order_statuses(', 'twe_get_order_status_name', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_ORDERED_STATUS_ID', '0', '6', '3', 'twe_cfg_pull_down_order_statuses(', 'twe_get_order_status_name', now())");   
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, use_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_FAILED_STATUS_ID', '0', '6', '3', 'twe_cfg_pull_down_order_statuses(', 'twe_get_order_status_name', now())");   
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_DEALERCODE', '', '6', '4', now());");    
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_RVG2C', '', '6', '4', now());"); 
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_VERIFY_KEY', '', '6', '4', now());"); 
     // $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_PASSCODE', '', '6', '6', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_SORT_ORDER', '0', '6', '0', now())");
     // $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CA','','6','7', now())");
     // $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_SMS_SB', '', '6', '1', now());");
     // $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_SMS_CUSB', '', '6', '1', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, set_function, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_MID', 'False', '6', '6', 'twe_cfg_select_option(array(\'True\', \'False\'), ', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value,  configuration_group_id, sort_order, date_added) values ('MODULE_PAYMENT_SMILEPAYCREDIT_MID_VALUE', '', '6', '6', now());");      
  }
  
  // compute Mid      
  function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
    $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
    $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
    $dtotal=$Mid_value. $Amount. $Smseid;                              
    
    $i = 1;
    $sum = strlen($dtotal);
    $etemp=0;      
    while ($i <= $sum)
    {
      $ep = substr($dtotal,$i,1);
      $etemp = $etemp + $ep;                
      $i=$i+2;
    }                
    
    $i = 0;  
    $otemp=0;          
    while ($i <= $sum)
    {                                              
      $op = substr($dtotal,$i,1);
      $otemp = $otemp + $op;
      $i=$i+2;
    } 
    
    $mid=($etemp*3)+($otemp*9);
  
    if($Mid_smilepay == $mid){
      return true;
    }else{
      return false;
    }
       
  }  

}
?>
